#include <amxmodx>
#include <hamsandwich>
#include <fakemeta>

#define PLUGIN_NAME "HS All Hooks"
#define PLUGIN_VERSION "0.1.1"
#define PLUGIN_AUTHOR "VEN"

#define GAME_MOD GAME_MOD_CSTRIKE

#define DO_POST_HOOKS 1

#define GAME_MOD_CSTRIKE	1
#define GAME_MOD_VALVE		2
#define GAME_MOD_GEARBOX	3

#if GAME_MOD == GAME_MOD_CSTRIKE

new const g_classes[][] = {
//	"ambient_generic",
//	"ammo_338magnum",
//	"ammo_357sig",
//	"ammo_45acp",
//	"ammo_50ae",
//	"ammo_556nato",
//	"ammo_556natobox",
//	"ammo_57mm",
//	"ammo_762nato",
//	"ammo_9mm",
//	"ammo_buckshot",
//	"armoury_entity",
//	"beam",
//	"bodyque",
//	"button_target",
//	"cycler",
//	"cycler_prdroid",
//	"cycler_sprite",
//	"cycler_weapon",
//	"cycler_wreckage",
//	"env_beam",
//	"env_beverage",
//	"env_blood",
//	"env_bombglow",
//	"env_bubbles",
//	"env_debris",
//	"env_explosion",
//	"env_fade",
//	"env_fog",
//	"env_funnel",
//	"env_global",
//	"env_glow",
//	"env_laser",
//	"env_lightning",
//	"env_message",
//	"env_rain",
//	"env_render",
//	"env_shake",
//	"env_shooter",
//	"env_snow",
//	"env_sound",
//	"env_spark",
//	"env_sprite",
//	"fireanddie",
//	"func_bomb_target",
//	"func_breakable",
//	"func_button",
//	"func_buyzone",
//	"func_conveyor",
//	"func_door",
//	"func_door_rotating",
//	"func_escapezone",
//	"func_friction",
//	"func_grencatch",
//	"func_guntarget",
//	"func_healthcharger",
//	"func_hostage_rescue",
//	"func_illusionary",
//	"func_ladder",
//	"func_monsterclip",
//	"func_mortar_field",
//	"func_pendulum",
//	"func_plat",
//	"func_platrot",
//	"func_pushable",
//	"func_rain",
//	"func_recharge",
//	"func_rot_button",
//	"func_rotating",
//	"func_snow",
//	"func_tank",
//	"func_tankcontrols",
//	"func_tanklaser",
//	"func_tankmortar",
//	"func_tankrocket",
//	"func_trackautochange",
//	"func_trackchange",
//	"func_tracktrain",
//	"func_train",
//	"func_traincontrols",
//	"func_vehicle",
//	"func_vehiclecontrols",
//	"func_vip_safetyzone",
//	"func_wall",
//	"func_wall_toggle",
//	"func_water",
//	"func_weaponcheck",
////	"g_flTimeLimit", // !!!CRASH
//	"game_counter",
//	"game_counter_set",
//	"game_end",
//	"game_player_equip",
//	"game_player_hurt",
//	"game_player_team",
//	"game_score",
//	"game_team_master",
//	"game_team_set",
//	"game_text",
//	"game_zone_player",
//	"gibshooter",
//	"grenade",
//	"hostage_entity",
//	"info_bomb_target",
//	"info_hostage_rescue",
//	"info_intermission",
//	"info_landmark",
//	"info_map_parameters",
//	"info_null",
//	"info_player_deathmatch",
//	"info_player_start",
//	"info_target",
//	"info_teleport_destination",
//	"info_vip_start",
//	"infodecal",
//	"item_airtank",
//	"item_antidote",
//	"item_assaultsuit",
//	"item_battery",
//	"item_healthkit",
//	"item_kevlar",
//	"item_longjump",
//	"item_security",
//	"item_sodacan",
//	"item_suit",
//	"item_thighpack",
//	"light",
//	"light_environment",
//	"light_spot",
//	"momentary_door",
//	"momentary_rot_button",
//	"monster_hevsuit_dead",
//	"monster_mortar",
////	"monster_scientist", // !!!PSEUDO-duplicate of hostage_entity, do not uncomment unless you want to get double handler call
//	"multi_manager",
//	"multisource",
//	"path_corner",
//	"path_track",
//	"player",
//	"player_loadsaved",
//	"player_weaponstrip",
//	"soundent",
//	"spark_shower",
//	"speaker",
//	"target_cdaudio",
//	"test_effect",
//	"trigger",
//	"trigger_auto",
//	"trigger_autosave",
//	"trigger_camera",
//	"trigger_cdaudio",
//	"trigger_changelevel",
//	"trigger_changetarget",
//	"trigger_counter",
//	"trigger_endsection",
//	"trigger_gravity",
//	"trigger_hurt",
//	"trigger_monsterjump",
//	"trigger_multiple",
//	"trigger_once",
//	"trigger_push",
//	"trigger_relay",
//	"trigger_teleport",
//	"trigger_transition",
//	"weapon_ak47",
//	"weapon_aug",
//	"weapon_awp",
//	"weapon_c4",
//	"weapon_deagle",
//	"weapon_elite",
//	"weapon_famas",
//	"weapon_fiveseven",
//	"weapon_flashbang",
//	"weapon_g3sg1",
//	"weapon_galil",
//	"weapon_glock18",
//	"weapon_hegrenade",
//	"weapon_knife",
//	"weapon_m249",
//	"weapon_m3",
//	"weapon_m4a1",
//	"weapon_mac10",
//	"weapon_mp5navy",
//	"weapon_p228",
//	"weapon_p90",
//	"weapon_scout",
//	"weapon_sg550",
//	"weapon_sg552",
//	"weapon_shield",
//	"weapon_smokegrenade",
//	"weapon_tmp",
//	"weapon_ump45",
//	"weapon_usp",
//	"weapon_xm1014",
//	"weaponbox",
//	"world_items",
	"worldspawn"
}

#endif

#if GAME_MOD == GAME_MOD_VALVE

new const g_classes[][] = {
	"aiscripted_sequence",
	"ambient_generic",
	"ammo_357",
	"ammo_9mmAR",
	"ammo_9mmbox",
	"ammo_9mmclip",
	"ammo_ARgrenades",
	"ammo_buckshot",
	"ammo_crossbow",
	"ammo_egonclip",
	"ammo_gaussclip",
	"ammo_glockclip",
	"ammo_mp5clip",
	"ammo_mp5grenades",
	"ammo_rpgclip",
	"beam",
	"bmortar",
	"bodyque",
	"button_target",
	"cine_blood",
	"controller_energy_ball",
	"controller_head_ball",
	"crossbow_bolt",
	"cycler",
	"cycler_prdroid",
	"cycler_sprite",
	"cycler_weapon",
	"cycler_wreckage",
	"env_beam",
	"env_beverage",
	"env_blood",
	"env_bubbles",
	"env_debris",
	"env_explosion",
	"env_fade",
	"env_funnel",
	"env_global",
	"env_glow",
	"env_laser",
	"env_lightning",
	"env_message",
	"env_render",
	"env_shake",
	"env_shooter",
	"env_smoker",
	"env_sound",
	"env_spark",
	"env_sprite",
	"fireanddie",
	"func_breakable",
	"func_button",
	"func_conveyor",
	"func_door",
	"func_door_rotating",
	"func_friction",
	"func_guntarget",
	"func_healthcharger",
	"func_illusionary",
	"func_ladder",
	"func_monsterclip",
	"func_mortar_field",
	"func_pendulum",
	"func_plat",
	"func_platrot",
	"func_pushable",
	"func_recharge",
	"func_rot_button",
	"func_rotating",
	"func_tank",
	"func_tankcontrols",
	"func_tanklaser",
	"func_tankmortar",
	"func_tankrocket",
	"func_trackautochange",
	"func_trackchange",
	"func_tracktrain",
	"func_train",
	"func_traincontrols",
	"func_wall",
	"func_wall_toggle",
	"func_water",
	"game_counter",
	"game_counter_set",
	"game_end",
	"game_player_equip",
	"game_player_hurt",
	"game_player_team",
	"game_score",
	"game_team_master",
	"game_team_set",
	"game_text",
	"game_zone_player",
	"garg_stomp",
	"gibshooter",
	"grenade",
	"hornet",
	"hvr_rocket",
	"info_bigmomma",
	"info_intermission",
	"info_landmark",
	"info_node",
	"info_node_air",
	"info_null",
	"info_player_deathmatch",
	"info_player_start",
	"info_target",
	"info_teleport_destination",
	"infodecal",
	"item_airtank",
	"item_antidote",
	"item_battery",
	"item_healthkit",
	"item_longjump",
	"item_security",
	"item_sodacan",
	"item_suit",
	"laser_spot",
	"light",
	"light_environment",
	"light_spot",
	"momentary_door",
	"momentary_rot_button",
	"monster_alien_controller",
	"monster_alien_grunt",
	"monster_alien_slave",
	"monster_apache",
	"monster_babycrab",
	"monster_barnacle",
	"monster_barney",
	"monster_barney_dead",
	"monster_bigmomma",
	"monster_bloater",
	"monster_bullchicken",
	"monster_cine2_hvyweapons",
	"monster_cine2_scientist",
	"monster_cine2_slave",
	"monster_cine3_barney",
	"monster_cine3_scientist",
	"monster_cine_barney",
	"monster_cine_panther",
	"monster_cine_scientist",
	"monster_cockroach",
	"monster_flyer",
	"monster_flyer_flock",
	"monster_furniture",
	"monster_gargantua",
	"monster_generic",
	"monster_gman",
	"monster_grunt_repel",
	"monster_headcrab",
	"monster_hevsuit_dead",
	"monster_hgrunt_dead",
	"monster_houndeye",
	"monster_human_assassin",
	"monster_human_grunt",
	"monster_ichthyosaur",
	"monster_leech",
	"monster_miniturret",
	"monster_mortar",
	"monster_nihilanth",
	"monster_osprey",
	"monster_rat",
	"monster_satchel",
	"monster_scientist",
	"monster_scientist_dead",
	"monster_sentry",
	"monster_sitting_scientist",
	"monster_snark",
	"monster_tentacle",
	"monster_tentaclemaw",
	"monster_tripmine",
	"monster_turret",
	"monster_vortigaunt",
	"monster_zombie",
	"monstermaker",
	"multi_manager",
	"multisource",
	"nihilanth_energy_ball",
	"node_viewer",
	"node_viewer_fly",
	"node_viewer_human",
	"node_viewer_large",
	"path_corner",
	"path_track",
	"player",
	"player_loadsaved",
	"player_weaponstrip",
	"rpg_rocket",
	"scripted_sentence",
	"scripted_sequence",
	"soundent",
	"spark_shower",
	"speaker",
	"squidspit",
	"streak_spiral",
	"target_cdaudio",
	"test_effect",
	"testhull",
	"trigger",
	"trigger_auto",
	"trigger_autosave",
	"trigger_camera",
	"trigger_cdaudio",
	"trigger_changelevel",
	"trigger_changetarget",
	"trigger_counter",
	"trigger_endsection",
	"trigger_gravity",
	"trigger_hurt",
	"trigger_monsterjump",
	"trigger_multiple",
	"trigger_once",
	"trigger_push",
	"trigger_relay",
	"trigger_teleport",
	"trigger_transition",
	"weapon_357",
	"weapon_9mmAR",
	"weapon_9mmhandgun",
	"weapon_crossbow",
	"weapon_crowbar",
	"weapon_egon",
	"weapon_gauss",
	"weapon_glock",
	"weapon_handgrenade",
	"weapon_hornetgun",
	"weapon_mp5",
	"weapon_python",
	"weapon_rpg",
	"weapon_satchel",
	"weapon_shotgun",
	"weapon_snark",
	"weapon_tripmine",
	"weaponbox",
	"world_items",
	"worldspawn",
	"xen_hair",
	"xen_hull",
	"xen_plantlight",
	"xen_spore_large",
	"xen_spore_medium",
	"xen_spore_small",
	"xen_tree",
	"xen_ttrigger"
}

#endif

#if GAME_MOD == GAME_MOD_GEARBOX

new const g_classes[][] = {
	"aiscripted_sequence",
	"ambient_generic",
	"ammo_357",
	"ammo_556",
	"ammo_762",
	"ammo_9mmAR",
	"ammo_9mmbox",
	"ammo_9mmclip",
	"ammo_ARgrenades",
	"ammo_buckshot",
	"ammo_crossbow",
	"ammo_eagleclip",
	"ammo_egonclip",
	"ammo_gaussclip",
	"ammo_glockclip",
	"ammo_mp5clip",
	"ammo_mp5grenades",
	"ammo_rpgclip",
	"ammo_spore",
	"beam",
	"bmortar",
	"bodyque",
	"button_target",
	"charged_bolt",
	"cine_blood",
	"controller_energy_ball",
	"controller_head_ball",
	"crossbow_bolt",
	"ctf_hudicon",
	"cycler",
	"cycler_prdroid",
	"cycler_sprite",
	"cycler_weapon",
	"cycler_wreckage",
	"displacer_ball",
	"eagle_laser",
	"env_beam",
	"env_beverage",
	"env_blood",
	"env_blowercannon",
	"env_bubbles",
	"env_debris",
	"env_electrified_wire",
	"env_explosion",
	"env_fade",
	"env_funnel",
	"env_genewormcloud",
	"env_genewormspawn",
	"env_global",
	"env_glow",
	"env_laser",
	"env_lightning",
	"env_message",
	"env_render",
	"env_rope",
	"env_shake",
	"env_shooter",
	"env_smoker",
	"env_sound",
	"env_spark",
	"env_sprite",
	"env_spritetrain",
	"fireanddie",
	"func_breakable",
	"func_button",
	"func_conveyor",
	"func_door",
	"func_door_rotating",
	"func_friction",
	"func_guntarget",
	"func_healthcharger",
	"func_illusionary",
	"func_ladder",
	"func_monsterclip",
	"func_mortar_field",
	"func_op4mortarcontroller",
	"func_pendulum",
	"func_plat",
	"func_platrot",
	"func_pushable",
	"func_recharge",
	"func_rot_button",
	"func_rotating",
	"func_tank",
	"func_tank_of",
	"func_tankcontrols",
	"func_tankcontrols_of",
	"func_tanklaser",
	"func_tanklaser_of",
	"func_tankmortar",
	"func_tankmortar_of",
	"func_tankrocket",
	"func_tankrocket_of",
	"func_trackautochange",
	"func_trackchange",
	"func_tracktrain",
	"func_train",
	"func_traincontrols",
	"func_wall",
	"func_wall_toggle",
	"func_water",
	"game_counter",
	"game_counter_set",
	"game_end",
	"game_player_equip",
	"game_player_hurt",
	"game_player_team",
	"game_score",
	"game_team_master",
	"game_team_set",
	"game_text",
	"game_zone_player",
	"garg_stomp",
	"gibshooter",
	"gonomeguts",
	"grapple_tip",
	"grenade",
	"hornet",
	"hvr_blkop_rocket",
	"hvr_rocket",
	"info_bigmomma",
	"info_ctfdetect",
	"info_ctfspawn",
	"info_ctfspawn_powerup",
	"info_displacer_earth_target",
	"info_displacer_xen_target",
	"info_intermission",
	"info_landmark",
	"info_node",
	"info_node_air",
	"info_null",
	"info_pitworm",
	"info_pitworm_steam_lock",
	"info_player_deathmatch",
	"info_player_start",
	"info_target",
	"info_teleport_destination",
	"infodecal",
	"item_airtank",
	"item_antidote",
	"item_battery",
	"item_ctfaccelerator",
	"item_ctfbackpack",
	"item_ctfbase",
	"item_ctfflag",
	"item_ctflongjump",
	"item_ctfportablehev",
	"item_ctfregeneration",
	"item_generic",
	"item_healthkit",
	"item_longjump",
	"item_nuclearbomb",
	"item_nuclearbombbutton",
	"item_nuclearbombtimer",
	"item_security",
	"item_sodacan",
	"item_suit",
	"item_vest",
	"laser_spot",
	"light",
	"light_environment",
	"light_spot",
	"momentary_door",
	"momentary_rot_button",
	"monster_ShockTrooper_dead",
	"monster_alien_babyvoltigore",
	"monster_alien_controller",
	"monster_alien_grunt",
	"monster_alien_slave",
	"monster_alien_slave_dead",
	"monster_alien_voltigore",
	"monster_apache",
	"monster_assassin_repel",
	"monster_babycrab",
	"monster_barnacle",
	"monster_barney",
	"monster_barney_dead",
	"monster_bigmomma",
	"monster_blkop_apache",
	"monster_blkop_osprey",
	"monster_bloater",
	"monster_bullchicken",
	"monster_cine2_hvyweapons",
	"monster_cine2_scientist",
	"monster_cine2_slave",
	"monster_cine3_barney",
	"monster_cine3_scientist",
	"monster_cine_barney",
	"monster_cine_panther",
	"monster_cine_scientist",
	"monster_cleansuit_scientist",
	"monster_cleansuit_scientist_dead",
	"monster_cockroach",
	"monster_drillsergeant",
	"monster_fgrunt_repel",
	"monster_flyer",
	"monster_flyer_flock",
	"monster_furniture",
	"monster_gargantua",
	"monster_generic",
	"monster_geneworm",
	"monster_gman",
	"monster_gonome",
	"monster_gonome_dead",
	"monster_grunt_ally_repel",
	"monster_grunt_repel",
	"monster_headcrab",
	"monster_hevsuit_dead",
	"monster_hfgrunt_dead",
	"monster_hgrunt_dead",
	"monster_houndeye",
	"monster_houndeye_dead",
	"monster_human_assassin",
	"monster_human_friendly_grunt",
	"monster_human_grunt",
	"monster_human_grunt_ally",
	"monster_human_grunt_ally_dead",
	"monster_human_medic_ally",
	"monster_human_torch_ally",
	"monster_ichthyosaur",
	"monster_leech",
	"monster_male_assassin",
	"monster_massassin_dead",
	"monster_medic_ally_repel",
	"monster_miniturret",
	"monster_mortar",
	"monster_nihilanth",
	"monster_op4loader",
	"monster_osprey",
	"monster_otis",
	"monster_otis_dead",
	"monster_penguin",
	"monster_pitdrone",
	"monster_pitworm",
	"monster_pitworm_up",
	"monster_rat",
	"monster_recruit",
	"monster_satchel",
	"monster_scientist",
	"monster_scientist_dead",
	"monster_sentry",
	"monster_shockroach",
	"monster_shocktrooper",
	"monster_shocktrooper_repel",
	"monster_sitting_cleansuit_scientist",
	"monster_sitting_scientist",
	"monster_skeleton_dead",
	"monster_snark",
	"monster_tentacle",
	"monster_tentaclemaw",
	"monster_torch_ally_repel",
	"monster_tripmine",
	"monster_turret",
	"monster_vortigaunt",
	"monster_zombie",
	"monster_zombie_barney",
	"monster_zombie_soldier",
	"monster_zombie_soldier_dead",
	"monstermaker",
	"mortar_shell",
	"multi_manager",
	"multisource",
	"nihilanth_energy_ball",
	"node_viewer",
	"node_viewer_fly",
	"node_viewer_human",
	"node_viewer_large",
	"op4mortar",
	"path_corner",
	"path_track",
	"pitdronespike",
	"pitworm_gib",
	"pitworm_gibshooter",
	"player",
	"player_loadsaved",
	"player_weaponstrip",
	"rope_sample",
	"rope_segment",
	"rpg_rocket",
	"scripted_sentence",
	"scripted_sequence",
	"shock_beam",
	"soundent",
	"spark_shower",
	"speaker",
	"spore",
	"squidspit",
	"streak_spiral",
	"target_cdaudio",
	"test_effect",
	"testhull",
	"trigger",
	"trigger_auto",
	"trigger_autosave",
	"trigger_camera",
	"trigger_cdaudio",
	"trigger_changelevel",
	"trigger_changetarget",
	"trigger_counter",
	"trigger_ctfgeneric",
	"trigger_endsection",
	"trigger_geneworm_hit",
	"trigger_gravity",
	"trigger_hurt",
	"trigger_kill_nogib",
	"trigger_monsterjump",
	"trigger_multiple",
	"trigger_once",
	"trigger_playerfreeze",
	"trigger_push",
	"trigger_relay",
	"trigger_teleport",
	"trigger_transition",
	"trigger_xen_return",
	"weapon_357",
	"weapon_9mmAR",
	"weapon_9mmhandgun",
	"weapon_crossbow",
	"weapon_crowbar",
	"weapon_displacer",
	"weapon_eagle",
	"weapon_egon",
	"weapon_gauss",
	"weapon_glock",
	"weapon_grapple",
	"weapon_handgrenade",
	"weapon_hornetgun",
	"weapon_knife",
	"weapon_m249",
	"weapon_mp5",
	"weapon_penguin",
	"weapon_pipewrench",
	"weapon_python",
	"weapon_rpg",
	"weapon_satchel",
	"weapon_shockrifle",
	"weapon_shockroach",
	"weapon_shotgun",
	"weapon_snark",
	"weapon_sniperrifle",
	"weapon_sporelauncher",
	"weapon_tripmine",
	"weaponbox",
	"world_items",
	"worldspawn",
	"xen_hair",
	"xen_hull",
	"xen_plantlight",
	"xen_spore_large",
	"xen_spore_medium",
	"xen_spore_small",
	"xen_tree",
	"xen_ttrigger"
}

#endif

new const g_hooks[][] = {
	"Spawn",
	"Precache",
	"Keyvalue",
	"ObjectCaps",
	"Activate",
	"SetObjectCollisionBox",
	"Classify",
	"DeathNotice",
	"TraceAttack",
	"TakeDamage",
	"TakeHealth",
	"Killed",
	"BloodColor",
	"TraceBleed",
	"IsTriggered",
	"MyMonsterPointer",
	"MySquadMonsterPointer",
	"GetToggleState",
	"AddPoints",
	"AddPointsToTeam",
	"AddPlayerItem",
	"RemovePlayerItem",
	"GiveAmmo",
	"GetDelay",
	"IsMoving",
	"OverrideReset",
	"DamageDecal",
	"SetToggleState",
	"StartSneaking",
	"StopSneaking",
	"OnControls",
	"IsSneaking",
	"IsAlive",
	"IsBSPModel",
	"ReflectGauss",
	"HasTarget",
	"IsInWorld",
	"IsPlayer",
	"IsNetClient",
	"TeamId",
	"GetNextTarget",
	"Think",
	"Touch",
	"Use",
	"Blocked",
	"Respawn",
	"UpdateOwner",
	"FBecomeProne",
	"Center",
	"EyePosition",
	"EarPosition",
	"BodyTarget",
	"Illumination",
	"FVisible",
	"FVecVisible",
	"Player_Jump",
	"Player_Duck",
	"Player_PreThink",
	"Player_PostThink",
	"Player_GetGunPosition",
	"Player_ShouldFadeOnDeath",
	"Player_ImpulseCommands",
	"Player_UpdateClientData",
	"Item_AddToPlayer",
	"Item_AddDuplicate",
	"Item_CanDeploy",
	"Item_Deploy",
	"Item_CanHolster",
	"Item_Holster",
	"Item_UpdateItemInfo",
	"Item_PreFrame",
	"Item_PostFrame",
	"Item_Drop",
	"Item_Kill",
	"Item_AttachToPlayer",
	"Item_PrimaryAmmoIndex",
	"Item_SecondaryAmmoIndex",
	"Item_UpdateClientData",
	"Item_GetWeaponPtr",
	"Item_ItemSlot",
	"Weapon_ExtractAmmo",
	"Weapon_ExtractClipAmmo",
	"Weapon_AddWeapon",
	"Weapon_PlayEmptySound",
	"Weapon_ResetEmptySound",
	"Weapon_SendWeaponAnim",
	"Weapon_IsUsable",
	"Weapon_PrimaryAttack",
	"Weapon_SecondaryAttack",
	"Weapon_Reload",
	"Weapon_WeaponIdle",
	"Weapon_RetireWeapon",
	"Weapon_ShouldWeaponIdle",
	"Weapon_UseDecrement",
	"	TS_BreakableRespawn",
	"	TS_CanUsedThroughWalls",
	"	TS_RespawnWait",
	"CS_Restart",
	"CS_RoundRespawn",
	"CS_Item_CanDrop",
	"CS_Item_GetMaxSpeed",
	"	DOD_RoundRespawn",
	"	DOD_RoundRespawnEnt",
	"	DOD_RoundStore",
	"	DOD_AreaSetIndex",
	"	DOD_AreaSendStatus",
	"	DOD_GetState",
	"	DOD_GetStateEnt",
	"	DOD_Item_CanDrop",
	"	TFC_EngineerUse",
	"	TFC_Finished",
	"	TFC_EmpExplode",
	"	TFC_CalcEmpDmgRad",
	"	TFC_TakeEmpBlast",
	"	TFC_EmpRemove",
	"	TFC_TakeConcussionBlast",
	"	TFC_Concuss",
	"	ESF_IsEnvModel",
	"	ESF_TakeDamage2",
	"	NS_GetPointValue",
	"	NS_AwardKill",
	"	NS_ResetEntity",
	"	NS_UpdateOnRemove",
	"	TS_GiveSlowMul",
	"	TS_GoSlow",
	"	TS_InSlow",
	"	TS_IsObjective",
	"	TS_EnableObjective",
	"	TS_OnFreeEntPrivateData",
	"	TS_ShouldCollide"
}

public plugin_natives() {
	fwd_info("PLUGIN_NATIVES")

	for (new i = _:Ham_Spawn; i < _:HAM_LAST_ENTRY_DONT_USE_ME_LOL; ++i) {
		if (g_hooks[i][0] == '^t')
			continue

		server_print("[%3d] %-25s", i, g_hooks[i])

		for (new j = 0; j < sizeof g_classes; ++j) {
			RegisterHam(Ham:i, g_classes[j], g_hooks[i], DO_POST_HOOKS)
		}
	}

	fwd_info("FORWARDS_REGISTERED")
}

public plugin_precache()		fwd_info("PLUGIN_PRECACHE")

public plugin_init() {
	register_plugin(PLUGIN_NAME, PLUGIN_VERSION, PLUGIN_AUTHOR)
	fwd_info("PLUGIN_INIT")
}

public plugin_cfg()			fwd_info("PLUGIN_CFG")

fwd_info(const info[], ent = 0) {
	static class[32]
	pev(ent, pev_classname, class, sizeof class - 1)
	server_print("[%5.10f]   %-25s   %3d   %s   [H]", get_gametime(), info, ent, class)
}

public Spawn(ent)			fwd_info("Spawn", ent)
public Precache(ent)			fwd_info("Precache", ent)
public Keyvalue(ent)			fwd_info("Keyvalue", ent)
public ObjectCaps(ent)			fwd_info("ObjectCaps", ent)
public Activate(ent)			fwd_info("Activate", ent)
public SetObjectCollisionBox(ent)	fwd_info("SetObjectCollisionBox", ent)
public Classify(ent)			fwd_info("Classify", ent)
public DeathNotice(ent)			fwd_info("DeathNotice", ent)
public TraceAttack(ent)			fwd_info("TraceAttack", ent)
public TakeDamage(ent)			fwd_info("TakeDamage", ent)
public TakeHealth(ent)			fwd_info("TakeHealth", ent)
public Killed(ent)			fwd_info("Killed", ent)
public BloodColor(ent)			fwd_info("BloodColor", ent)
public TraceBleed(ent)			fwd_info("TraceBleed", ent)
public IsTriggered(ent)			fwd_info("IsTriggered", ent)
public MyMonsterPointer(ent)		fwd_info("MyMonsterPointer", ent)
public MySquadMonsterPointer(ent)	fwd_info("MySquadMonsterPointer", ent)
public GetToggleState(ent)		fwd_info("GetToggleState", ent)
public AddPoints(ent)			fwd_info("AddPoints", ent)
public AddPointsToTeam(ent)		fwd_info("AddPointsToTeam", ent)
public AddPlayerItem(ent)		fwd_info("AddPlayerItem", ent)
public RemovePlayerItem(ent)		fwd_info("RemovePlayerItem", ent)
public GiveAmmo(ent)			fwd_info("GiveAmmo", ent)
public GetDelay(ent)			fwd_info("GetDelay", ent)
public IsMoving(ent)			fwd_info("IsMoving", ent)
public OverrideReset(ent)		fwd_info("OverrideReset", ent)
public DamageDecal(ent)			fwd_info("DamageDecal", ent)
public SetToggleState(ent)		fwd_info("SetToggleState", ent)
public StartSneaking(ent)		fwd_info("StartSneaking", ent)
public StopSneaking(ent)		fwd_info("StopSneaking", ent)
public OnControls(ent)			fwd_info("OnControls", ent)
public IsSneaking(ent)			fwd_info("IsSneaking", ent)
public IsAlive(ent)			fwd_info("IsAlive", ent)
public IsBSPModel(ent)			fwd_info("IsBSPModel", ent)
public ReflectGauss(ent)		fwd_info("ReflectGauss", ent)
public HasTarget(ent)			fwd_info("HasTarget", ent)
public IsInWorld(ent)			fwd_info("IsInWorld", ent)
public IsPlayer(ent)			fwd_info("IsPlayer", ent)
public IsNetClient(ent)			fwd_info("IsNetClient", ent)
public TeamId(ent)			fwd_info("TeamId", ent)
public GetNextTarget(ent)		fwd_info("GetNextTarget", ent)
public Think(ent)			fwd_info("Think", ent)
public Touch(ent)			fwd_info("Touch", ent)
public Use(ent)				fwd_info("Use", ent)
public Blocked(ent)			fwd_info("Blocked", ent)
public Respawn(ent)			fwd_info("Respawn", ent)
public UpdateOwner(ent)			fwd_info("UpdateOwner", ent)
public FBecomeProne(ent)		fwd_info("FBecomeProne", ent)
public Center(ent)			fwd_info("Center", ent)
public EyePosition(ent)			fwd_info("EyePosition", ent)
public EarPosition(ent)			fwd_info("EarPosition", ent)
public BodyTarget(ent)			fwd_info("BodyTarget", ent)
public Illumination(ent)		fwd_info("Illumination", ent)
public FVisible(ent)			fwd_info("FVisible", ent)
public FVecVisible(ent)			fwd_info("FVecVisible", ent)
public Player_Jump(ent)			fwd_info("Player_Jump", ent)
public Player_Duck(ent)			fwd_info("Player_Duck", ent)
public Player_PreThink(ent)		fwd_info("Player_PreThink", ent)
public Player_PostThink(ent)		fwd_info("Player_PostThink", ent)
public Player_GetGunPosition(ent)	fwd_info("Player_GetGunPosition", ent)
public Player_ShouldFadeOnDeath(ent)	fwd_info("Player_ShouldFadeOnDeath", ent)
public Player_ImpulseCommands(ent)	fwd_info("Player_ImpulseCommands", ent)
public Player_UpdateClientData(ent)	fwd_info("Player_UpdateClientData", ent)
public Item_AddToPlayer(ent)		fwd_info("Item_AddToPlayer", ent)
public Item_AddDuplicate(ent)		fwd_info("Item_AddDuplicate", ent)
public Item_CanDeploy(ent)		fwd_info("Item_CanDeploy", ent)
public Item_Deploy(ent)			fwd_info("Item_Deploy", ent)
public Item_CanHolster(ent)		fwd_info("Item_CanHolster", ent)
public Item_Holster(ent)		fwd_info("Item_Holster", ent)
public Item_UpdateItemInfo(ent)		fwd_info("Item_UpdateItemInfo", ent)
public Item_PreFrame(ent)		fwd_info("Item_PreFrame", ent)
public Item_PostFrame(ent)		fwd_info("Item_PostFrame", ent)
public Item_Drop(ent)			fwd_info("Item_Drop", ent)
public Item_Kill(ent)			fwd_info("Item_Kill", ent)
public Item_AttachToPlayer(ent)		fwd_info("Item_AttachToPlayer", ent)
public Item_PrimaryAmmoIndex(ent)	fwd_info("Item_PrimaryAmmoIndex", ent)
public Item_SecondaryAmmoIndex(ent)	fwd_info("Item_SecondaryAmmoIndex", ent)
public Item_UpdateClientData(ent)	fwd_info("Item_UpdateClientData", ent)
public Item_GetWeaponPtr(ent)		fwd_info("Item_GetWeaponPtr", ent)
public Item_ItemSlot(ent)		fwd_info("Item_ItemSlot", ent)
public Weapon_ExtractAmmo(ent)		fwd_info("Weapon_ExtractAmmo", ent)
public Weapon_ExtractClipAmmo(ent)	fwd_info("Weapon_ExtractClipAmmo", ent)
public Weapon_AddWeapon(ent)		fwd_info("Weapon_AddWeapon", ent)
public Weapon_PlayEmptySound(ent)	fwd_info("Weapon_PlayEmptySound", ent)
public Weapon_ResetEmptySound(ent)	fwd_info("Weapon_ResetEmptySound", ent)
public Weapon_SendWeaponAnim(ent)	fwd_info("Weapon_SendWeaponAnim", ent)
public Weapon_IsUsable(ent)		fwd_info("Weapon_IsUsable", ent)
public Weapon_PrimaryAttack(ent)	fwd_info("Weapon_PrimaryAttack", ent)
public Weapon_SecondaryAttack(ent)	fwd_info("Weapon_SecondaryAttack", ent)
public Weapon_Reload(ent)		fwd_info("Weapon_Reload", ent)
public Weapon_WeaponIdle(ent)		fwd_info("Weapon_WeaponIdle", ent)
public Weapon_RetireWeapon(ent)		fwd_info("Weapon_RetireWeapon", ent)
public Weapon_ShouldWeaponIdle(ent)	fwd_info("Weapon_ShouldWeaponIdle", ent)
public Weapon_UseDecrement(ent)		fwd_info("Weapon_UseDecrement", ent)
public TS_BreakableRespawn(ent)		fwd_info("TS_BreakableRespawn", ent)
public TS_CanUsedThroughWalls(ent)	fwd_info("TS_CanUsedThroughWalls", ent)
public TS_RespawnWait(ent)		fwd_info("TS_RespawnWait", ent)
public CS_Restart(ent)			fwd_info("CS_Restart", ent)
public CS_RoundRespawn(ent)		fwd_info("CS_RoundRespawn", ent)
public CS_Item_CanDrop(ent)		fwd_info("CS_Item_CanDrop", ent)
public CS_Item_GetMaxSpeed(ent)		fwd_info("CS_Item_GetMaxSpeed", ent)
public DOD_RoundRespawn(ent)		fwd_info("DOD_RoundRespawn", ent)
public DOD_RoundRespawnEnt(ent)		fwd_info("DOD_RoundRespawnEnt", ent)
public DOD_RoundStore(ent)		fwd_info("DOD_RoundStore", ent)
public DOD_AreaSetIndex(ent)		fwd_info("DOD_AreaSetIndex", ent)
public DOD_AreaSendStatus(ent)		fwd_info("DOD_AreaSendStatus", ent)
public DOD_GetState(ent)		fwd_info("DOD_GetState", ent)
public DOD_GetStateEnt(ent)		fwd_info("DOD_GetStateEnt", ent)
public DOD_Item_CanDrop(ent)		fwd_info("DOD_Item_CanDrop", ent)
public TFC_EngineerUse(ent)		fwd_info("TFC_EngineerUse", ent)
public TFC_Finished(ent)		fwd_info("TFC_Finished", ent)
public TFC_EmpExplode(ent)		fwd_info("TFC_EmpExplode", ent)
public TFC_CalcEmpDmgRad(ent)		fwd_info("TFC_CalcEmpDmgRad", ent)
public TFC_TakeEmpBlast(ent)		fwd_info("TFC_TakeEmpBlast", ent)
public TFC_EmpRemove(ent)		fwd_info("TFC_EmpRemove", ent)
public TFC_TakeConcussionBlast(ent)	fwd_info("TFC_TakeConcussionBlast", ent)
public TFC_Concuss(ent)			fwd_info("TFC_Concuss", ent)
public ESF_IsEnvModel(ent)		fwd_info("ESF_IsEnvModel", ent)
public ESF_TakeDamage2(ent)		fwd_info("ESF_TakeDamage2", ent)
public NS_GetPointValue(ent)		fwd_info("NS_GetPointValue", ent)
public NS_AwardKill(ent)		fwd_info("NS_AwardKill", ent)
public NS_ResetEntity(ent)		fwd_info("NS_ResetEntity", ent)
public NS_UpdateOnRemove(ent)		fwd_info("NS_UpdateOnRemove", ent)
public TS_GiveSlowMul(ent)		fwd_info("TS_GiveSlowMul", ent)
public TS_GoSlow(ent)			fwd_info("TS_GoSlow", ent)
public TS_InSlow(ent)			fwd_info("TS_InSlow", ent)
public TS_IsObjective(ent)		fwd_info("TS_IsObjective", ent)
public TS_EnableObjective(ent)		fwd_info("TS_EnableObjective", ent)
public TS_OnFreeEntPrivateData(ent)	fwd_info("TS_OnFreeEntPrivateData", ent)
public TS_ShouldCollide(ent)		fwd_info("TS_ShouldCollide", ent)
